///////////////////////////////////////////////////////////////////////////////
// Triplet Interface class
//
// Last update: 01/12/2012
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Native JAVA imports
///////////////////////////////////////////////////////////////////////////////

import java.awt.Choice;
import java.awt.Color;
import java.awt.TextField;
import java.awt.FlowLayout;
import java.awt.Button;
import java.awt.Label;
import java.awt.Font;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Checkbox;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;


///////////////////////////////////////////////////////////////////////////////
// JavaView imports
///////////////////////////////////////////////////////////////////////////////
import jv.object.PsPanel;
import jv.object.PsUpdateIf;
import jv.project.PjProject_IP;


///////////////////////////////////////////////////////////////////////////////
// Info panel for graph tomography applet.
///////////////////////////////////////////////////////////////////////////////
public class PjTriplet_IP extends PjProject_IP implements ActionListener, ItemListener
{
   protected PjTriplet m_pjTriplet;
   protected PsPanel lettersPanel;
   protected Choice letter1;
   protected Choice letter2;
   protected Choice letter3;
   protected Button verifyButton;
   protected int[] number_of_triplets = {75, 100, 102, 110};
   protected Triplet[] triplet;
   protected int idx = 0;
   protected int score = 0;
   protected Label scoreLabel;
   protected Label messageLabel;   
   protected Label visualizationLabel;
   protected int[] shuffle;
   protected Checkbox viewAxes;
   protected Checkbox viewPlanes;   
   
   protected Label debugLabel;
   protected int number_of_trials = 0;
   protected int max_number_of_trials = 5;
   protected boolean correct_answer = false;
   
   protected int level = 0;
   protected int idiom = 0;
   protected int length;
   
   protected TextArea log;
   protected int[] log_trials;
   protected String[] log_triplets;
   
   protected KeyListener internalKeyListener1;
   protected KeyListener internalKeyListener2;
   protected KeyListener internalKeyListener3;   

   protected String[] title_trans = {"Trip-Lets usando Palavras do Dicionrio",
                                     "Trip-Lets using Dictionary's Words",
				     "Trip-Lets usando Palabras del Diccionrio"};

   protected String[] verify_trans = {"Acertei?",
                                      "Check My Answer!",
				      "Acert?"};
   protected String[] score_trans = {"Pontuao: ", "Score: ", "Puntuacin: "};

   protected String[] visualization_trans = {"Opes de Visualizao",
                                             "Visualization Options",
					     "Opciones de Visualizacin"};
   protected String[] axes_trans = {"Eixos coordenados", "Coordinate axes","Ejes coordenados"};

   protected String[] planes_trans = {"Planos coordenados",
                                      "Coordinate planes",
				      "Planos coordenados"};

   protected String[] end_of_the_game_trans =
                           {"Fim de jogo! Parabns!",
                            "End of the game! Congratulations!",
			    "Fin del juego! Felicidades!"};

   protected String[] success_trans = {"Parabns! Tente agora o desafio de nmero ",
                                       "Congratulations! Now, try the puzzle ",
				       "Felicidades! Ahora, intente con el desafo"};

   protected String[] next_trans = {"Tente agora o desafio de nmero ",
                                    "Now, try the puzzle ",
				    "Ahora intente con el desafo"};

   protected String[] advice_trans =
                           {"Lembre-se de colocar as letras na ordem correta!",
                            "Remember to put the letters in the correct order!",
			    "Recuerde colocar las letras en el orden correcto!"};

   protected String[] failure_trans = {"Ainda no! Tente outra vez!",
                                       "Not yet! Try again!",
				       "Incorrecto! Intente de nuevo"};

   protected String[] answers_trans = {"Respostas possveis: ", "Possible answers: ", "Posibles respuestas: "};
   protected String[] answer_trans = {"Resposta: ", "Answer: ","Respuesta: "};

   protected String[] of_trans = {"de", "of", "de"};

   protected String[] log_trans = {"Aqui esto as trip-lets que voc tentou:",
                                   "Here are the trip-lets you've tried:",
                                   "Estas son las palabras que se han tratado:"};
   protected String[] trial_trans = {"tentativa", "tryout", "intento"};
   protected String[] trials_trans = {"tentativas", "tryouts", "intentos"};
   protected String[] hit_trans = {"acertou de primeira", "direct hit", "acert de primera"};
   
   
   ///////////////////////////////////////////////////////////////////////////
   // Default constructor
   ///////////////////////////////////////////////////////////////////////////
   public PjTriplet_IP()
   {
      super();           
      
      this.addTitle(title_trans[0]);
      
      this.add(new Label(" "));
      
      lettersPanel = new PsPanel();
      this.add(lettersPanel);
      
      this.add(new Label(" "));
           
      verifyButton = new Button(verify_trans[0]);
      verifyButton.addActionListener(this);
      
      this.add(verifyButton);
      
      this.add(new Label(" "));
      scoreLabel = new Label(score_trans[0] + score, Label.CENTER);
      this.add(scoreLabel);
      
      add(new Label(" "));
      messageLabel = new Label(" ", Label.CENTER);
      this.add(messageLabel);
      
      this.add(new Label(" "));      
      this.addLine(1);      

      visualizationLabel = new Label(visualization_trans[0], Label.CENTER);
      visualizationLabel.setFont(new Font("TimesRoman", Font.BOLD, 14));
      this.add(visualizationLabel);
      
      this.add(new Label(" "));
      
      Panel viewPanel = new Panel();
      viewPanel.setLayout(new GridLayout(1, 2));

      viewAxes = new Checkbox(axes_trans[0]);
      viewAxes.addItemListener(this);
      viewAxes.setState(false);
      viewPanel.add(viewAxes);

      viewPlanes = new Checkbox(planes_trans[0]);
      viewPlanes.addItemListener(this);
      viewPlanes.setState(false);
      viewPanel.add(viewPlanes);
      
      Panel c = new Panel();
      c.setLayout(new BorderLayout());
      c.add(new Label(" "), BorderLayout.WEST);
      c.add(viewPanel, BorderLayout.CENTER);
      
      this.add(c);

      add(new Label(" "));      
      
      debugLabel = new Label(" ", Label.CENTER);
      
      
      if (getClass() == PjTriplet_IP.class)
      {
         init();
      };
   }; // End of PjTriplet_IP()


   //////////////////////////////////////////////////////////////////////////
   // Setup the main control panel
   //////////////////////////////////////////////////////////////////////////
   public void init()
   {
      super.init();           
   }; // End of init()


   //////////////////////////////////////////////////////////////////////////
   // Setup parent and add the level slider
   //////////////////////////////////////////////////////////////////////////
   public void setParent(PsUpdateIf parent)
   {
       super.setParent(parent);
       m_pjTriplet = (PjTriplet) parent;
       level = m_pjTriplet.level;
       idiom = m_pjTriplet.idiom;
       length = m_pjTriplet.length;
       log_trials = new int[length];
       log_triplets = new String[length];

       triplet = new Triplet[number_of_triplets[level]];
       shuffle = new int[number_of_triplets[level]];
       
       // Shuffle 
       for(int i = 0; i < number_of_triplets[level]; i++)
       {
         shuffle[i] = i;          
       }
       
       for (int i = 0; i < number_of_triplets[level]; i++) 
       {
          int r = i + (int) (Math.random() * (number_of_triplets[level] - i)); 
          int swap = shuffle[i];
          shuffle[i] = shuffle[r];
          shuffle[r] = swap;                               
       }
             
       // Idiom 
       setTitle(title_trans[idiom]);
       verifyButton.setLabel(verify_trans[idiom]);
       scoreLabel.setText(score_trans[idiom] + score);
       visualizationLabel.setText(visualization_trans[idiom]);
       viewAxes.setLabel(axes_trans[idiom]);
       viewPlanes.setLabel(planes_trans[idiom]);
       
       // Trip-lets info       
       int i = 0;

       String[] str;
       
       if ((level <= 1) || (level > 2))
       {
              str =  new String[] {"ABA"};
              triplet[i] = new Triplet("triplet-br-aba.off", 1, str);
              i++;

              str =  new String[] {"AME", "EMA"};
              triplet[i] = new Triplet("triplet-br-ame.off", 2, str);
              i++;

              str =  new String[] {"ARO", "ROA", "ORA"};
              triplet[i] = new Triplet("triplet-br-aro.off", 3, str);
              i++;

              str =  new String[] {"ASA", "AAS"};
              triplet[i] = new Triplet("triplet-br-asa.off", 2, str);
              i++;

              str =  new String[] {"ATA"};
              triplet[i] = new Triplet("triplet-br-ata.off", 1, str);
              i++;

              str =  new String[] {"ATO", "TAO", "TOA", "OTA"};
              triplet[i] = new Triplet("triplet-br-ato.off", 4, str);
              i++;

              str =  new String[] {"AVO", "VOA", "OVA"};
              triplet[i] = new Triplet("triplet-br-avo.off", 3, str);
              i++;

              str =  new String[] {"BAR"};
              triplet[i] = new Triplet("triplet-br-bar.off", 1, str);
              i++;

              str =  new String[] {"BEM", "WEB"};
              triplet[i] = new Triplet("triplet-br-bem.off", 2, str);
              i++;

              str =  new String[] {"BOA", "OBA", "OAB"};
              triplet[i] = new Triplet("triplet-br-boa.off", 3, str);
              i++;

              str =  new String[] {"BOM"};
              triplet[i] = new Triplet("triplet-br-bom.off", 1, str);
              i++;

              str =  new String[] {"CAL"};
              triplet[i] = new Triplet("triplet-br-cal.off", 1, str);
              i++;

              str =  new String[] {"CEM", "MCE", "MEC"};
              triplet[i] = new Triplet("triplet-br-cem.off", 3, str);
              i++;

              str =  new String[] {"COR"};
              triplet[i] = new Triplet("triplet-br-cor.off", 1, str);
              i++;

              str =  new String[] {"CRU"};
              triplet[i] = new Triplet("triplet-br-cru.off", 1, str);
              i++;

              str =  new String[] {"DEZ"};
              triplet[i] = new Triplet("triplet-br-dez.off", 1, str);
              i++;

              str =  new String[] {"DIA", "DAI", "IDA", "ADI"};
              triplet[i] = new Triplet("triplet-br-dia.off", 4, str);
              i++;

              str =  new String[] {"DOR"};
              triplet[i] = new Triplet("triplet-br-dor.off", 1, str);
              i++;

              str =  new String[] {"ECO", "COE"};
              triplet[i] = new Triplet("triplet-br-eco.off", 2, str);
              i++;

              str =  new String[] {"EGO", "GEO"};
              triplet[i] = new Triplet("triplet-br-ego.off", 2, str);
              i++;

              str =  new String[] {"ELA"};
              triplet[i] = new Triplet("triplet-br-ela.off", 1, str);
              i++;

              str =  new String[] {"ELE"};
              triplet[i] = new Triplet("triplet-br-ele.off", 1, str);
              i++;

              str =  new String[] {"ELO"};
              triplet[i] = new Triplet("triplet-br-elo.off", 1, str);
              i++;

              str =  new String[] {"EMA", "AME"};
              triplet[i] = new Triplet("triplet-br-ema.off", 2, str);
              i++;

              str =  new String[] {"ERA", "ARE"};
              triplet[i] = new Triplet("triplet-br-era.off", 2, str);
              i++;

              str =  new String[] {"FAZ"};
              triplet[i] = new Triplet("triplet-br-faz.off", 1, str);
              i++;

              str =  new String[] {"FEZ"};
              triplet[i] = new Triplet("triplet-br-fez.off", 1, str);
              i++;

              str =  new String[] {"FIM", "FMI"};
              triplet[i] = new Triplet("triplet-br-fim.off", 2, str);
              i++;

              str =  new String[] {"GOL", "LOG"};
              triplet[i] = new Triplet("triplet-br-gol.off", 2, str);
              i++;

              str =  new String[] {"IDA", "DIA", "DAI", "ADI"};
              triplet[i] = new Triplet("triplet-br-ida.off", 4, str);
              i++;

              str =  new String[] {"IRA", "RIA"};
              triplet[i] = new Triplet("triplet-br-ira.off", 2, str);
              i++;

              str =  new String[] {"LAR"};
              triplet[i] = new Triplet("triplet-br-lar.off", 1, str);
              i++;

              str =  new String[] {"LEI"};
              triplet[i] = new Triplet("triplet-br-lei.off", 1, str);
              i++;

              str =  new String[] {"LER"};
              triplet[i] = new Triplet("triplet-br-ler.off", 1, str);
              i++;

              str =  new String[] {"LOG", "GOL"};
              triplet[i] = new Triplet("triplet-br-log.off", 2, str);
              i++;

              str =  new String[] {"LUA", "ULA"};
              triplet[i] = new Triplet("triplet-br-lua.off", 2, str);
              i++;

              str =  new String[] {"LUZ"};
              triplet[i] = new Triplet("triplet-br-luz.off", 1, str);
              i++;

              str =  new String[] {"MAL"};
              triplet[i] = new Triplet("triplet-br-mal.off", 1, str);
              i++;

              str =  new String[] {"MAR", "RAM"};
              triplet[i] = new Triplet("triplet-br-mar.off", 2, str);
              i++;

              str =  new String[] {"MEL"};
              triplet[i] = new Triplet("triplet-br-mel.off", 1, str);
              i++;

              str =  new String[] {"MIL", "IML"};
              triplet[i] = new Triplet("triplet-br-mil.off", 2, str);
              i++;

              str =  new String[] {"NAU", "NUA", "ANU", "UNA"};
              triplet[i] = new Triplet("triplet-br-nau.off", 4, str);
              i++;

              str =  new String[] {"NUA", "NAU", "UNA", "ANU"};
              triplet[i] = new Triplet("triplet-br-nua.off", 4, str);
              i++;

              str =  new String[] {"OAB", "OBA", "BOA"};
              triplet[i] = new Triplet("triplet-br-oab.off", 3, str);
              i++;

              str =  new String[] {"OBA", "OAB", "BOA"};
              triplet[i] = new Triplet("triplet-br-oba.off", 3, str);
              i++;

              str =  new String[] {"OCA", "COA"};
              triplet[i] = new Triplet("triplet-br-oca.off", 2, str);
              i++;

              str =  new String[] {"OCO", "COO"};
              triplet[i] = new Triplet("triplet-br-oco.off", 2, str);
              i++;

              str =  new String[] {"OLA", "LOA", "LAO"};
              triplet[i] = new Triplet("triplet-br-ola.off", 3, str);
              i++;

              str =  new String[] {"ORA", "ROA", "ARO"};
              triplet[i] = new Triplet("triplet-br-ora.off", 3, str);
              i++;

              str =  new String[] {"PAI", "PIA", "API", "IPA"};
              triplet[i] = new Triplet("triplet-br-pai.off", 4, str);
              i++;

              str =  new String[] {"PAR", "PRA", "RAP"};
              triplet[i] = new Triplet("triplet-br-par.off", 3, str);
              i++;

              str =  new String[] {"PAU", "PUA", "UPA"};
              triplet[i] = new Triplet("triplet-br-pau.off", 3, str);
              i++;

              str =  new String[] {"PAZ", "PAN"};
              triplet[i] = new Triplet("triplet-br-paz.off", 2, str);
              i++;

              str =  new String[] {"PIA", "PAI", "IPA", "API"};
              triplet[i] = new Triplet("triplet-br-pia.off", 4, str);
              i++;

              str =  new String[] {"POR", "PRO"};
              triplet[i] = new Triplet("triplet-br-por.off", 2, str);
              i++;

              str =  new String[] {"PUS"};
              triplet[i] = new Triplet("triplet-br-pus.off", 1, str);
              i++;

              str =  new String[] {"REI"};
              triplet[i] = new Triplet("triplet-br-rei.off", 1, str);
              i++;

              str =  new String[] {"RIM", "MIR"};
              triplet[i] = new Triplet("triplet-br-rim.off", 2, str);
              i++;

              str =  new String[] {"RIO", "ORI"};
              triplet[i] = new Triplet("triplet-br-rio.off", 2, str);
              i++;

              str =  new String[] {"RIR"};
              triplet[i] = new Triplet("triplet-br-rir.off", 1, str);
              i++;

              str =  new String[] {"RUA", "URA", "ARU"};
              triplet[i] = new Triplet("triplet-br-rua.off", 3, str);
              i++;

              str =  new String[] {"SAL", "LAS"};
              triplet[i] = new Triplet("triplet-br-sal.off", 2, str);
              i++;

              str =  new String[] {"SEU", "SUE", "USE"};
              triplet[i] = new Triplet("triplet-br-seu.off", 3, str);
              i++;

              str =  new String[] {"SOB"};
              triplet[i] = new Triplet("triplet-br-sob.off", 1, str);
              i++;

              str =  new String[] {"SOL", "LOS"};
              triplet[i] = new Triplet("triplet-br-sol.off", 2, str);
              i++;

              str =  new String[] {"SOM", "OMS", "MOS"};
              triplet[i] = new Triplet("triplet-br-som.off", 3, str);
              i++;

              str =  new String[] {"SUA", "USA"};
              triplet[i] = new Triplet("triplet-br-sua.off", 2, str);
              i++;

              str =  new String[] {"SUB", "BUS"};
              triplet[i] = new Triplet("triplet-br-sub.off", 2, str);
              i++;

              str =  new String[] {"SUL"};
              triplet[i] = new Triplet("triplet-br-sul.off", 1, str);
              i++;

              str =  new String[] {"TER", "TRE"};
              triplet[i] = new Triplet("triplet-br-ter.off", 2, str);
              i++;

              str =  new String[] {"TIA", "TAI", "ITA", "ATI"};
              triplet[i] = new Triplet("triplet-br-tia.off", 4, str);
              i++;

              str =  new String[] {"TIO", "OTI", "OIT"};
              triplet[i] = new Triplet("triplet-br-tio.off", 3, str);
              i++;

              str =  new String[] {"USO", "SUO", "SOU"};
              triplet[i] = new Triplet("triplet-br-uso.off", 3, str);
              i++;

              str =  new String[] {"UVA", "VAU"};
              triplet[i] = new Triplet("triplet-br-uva.off", 2, str);
              i++;

              str =  new String[] {"VOA", "OVA", "AVO"};
              triplet[i] = new Triplet("triplet-br-voa.off", 3, str);
              i++;
       };
       
       if (level == 1)
       {
              str =  new String[] {"MIA", "IAM", "AMI"};
              triplet[i] = new Triplet("triplet-br-mia.off", 3, str);
              i++;
    	   
              str =  new String[] {"ABC", "CBA"};
              triplet[i] = new Triplet("triplet-br-abc.off", 2, str);
              i++;

              str =  new String[] {"BCG"};
              triplet[i] = new Triplet("triplet-br-bcg.off", 1, str);
              i++;

              str =  new String[] {"BIT"};
              triplet[i] = new Triplet("triplet-br-bit.off", 1, str);
              i++;

              str =  new String[] {"CEP"};
              triplet[i] = new Triplet("triplet-br-cep.off", 1, str);
              i++;

              str =  new String[] {"CPF"};
              triplet[i] = new Triplet("triplet-br-cpf.off", 1, str);
              i++;

              str =  new String[] {"CPI"};
              triplet[i] = new Triplet("triplet-br-cpi.off", 1, str);
              i++;

              str =  new String[] {"DNA", "ADN"};
              triplet[i] = new Triplet("triplet-br-dna.off", 2, str);
              i++;

              str =  new String[] {"EUA"};
              triplet[i] = new Triplet("triplet-br-eua.off", 1, str);
              i++;

              str =  new String[] {"FAX"};
              triplet[i] = new Triplet("triplet-br-fax.off", 1, str);
              i++;

              str =  new String[] {"IBM"};
              triplet[i] = new Triplet("triplet-br-ibm.off", 1, str);
              i++;

              str =  new String[] {"JAZ"};
              triplet[i] = new Triplet("triplet-br-jaz.off", 1, str);
              i++;

              str =  new String[] {"LSD"};
              triplet[i] = new Triplet("triplet-br-lsd.off", 1, str);
              i++;

              str =  new String[] {"MCT", "TCM"};
              triplet[i] = new Triplet("triplet-br-mct.off", 2, str);
              i++;
                
              str =  new String[] {"MDC"};
              triplet[i] = new Triplet("triplet-br-mdc.off", 1, str);
              i++;
                
              str =  new String[] {"MMC"};
              triplet[i] = new Triplet("triplet-br-mmc.off", 1, str);
              i++;

              str =  new String[] {"PIB"};
              triplet[i] = new Triplet("triplet-br-pib.off", 1, str);
              i++;

              str =  new String[] {"PUC", "UCP", "CPU"};
              triplet[i] = new Triplet("triplet-br-puc.off", 3, str);
              i++;

              str =  new String[] {"SAC"};
              triplet[i] = new Triplet("triplet-br-sac.off", 1, str);
              i++;

              str =  new String[] {"SOS"};
              triplet[i] = new Triplet("triplet-br-sos.off", 1, str);
              i++;

              str =  new String[] {"TAM", "ATM"};
              triplet[i] = new Triplet("triplet-br-tam.off", 2, str);
              i++;

              str =  new String[] {"TNT"};
              triplet[i] = new Triplet("triplet-br-tnt.off", 1, str);
              i++;

              str =  new String[] {"USA", "SUA"};
              triplet[i] = new Triplet("triplet-br-usa.off", 2, str);
              i++;

              str =  new String[] {"WEB", "BEM"};
              triplet[i] = new Triplet("triplet-br-web.off", 2, str);
              i++;

              str =  new String[] {"ZOO"};
              triplet[i] = new Triplet("triplet-br-zoo.off", 1, str);              
              i++;           
       };
       
       if (level == 2)
       {
           str =  new String[] {"FAR", "RAF"};
           triplet[i] = new Triplet("triplet-en-far.off", 2, str);
           i++;

           str =  new String[] {"ABC", "CAB"};
           triplet[i] = new Triplet("triplet-en-abc.off", 2, str);
           i++;

           str =  new String[] {"ACE"};
           triplet[i] = new Triplet("triplet-en-ace.off", 1, str);
           i++;

           str =  new String[] {"AGE"};
           triplet[i] = new Triplet("triplet-en-age.off", 1, str);
           i++;

           str =  new String[] {"AGO"};
           triplet[i] = new Triplet("triplet-en-ago.off", 1, str);
           i++;

           str =  new String[] {"AID"};
           triplet[i] = new Triplet("triplet-en-aid.off", 1, str);
           i++;

           str =  new String[] {"AIM", "MIA"};
           triplet[i] = new Triplet("triplet-en-aim.off", 2, str);
           i++;

           str =  new String[] {"AIR"};
           triplet[i] = new Triplet("triplet-en-air.off", 1, str);
           i++;

           str =  new String[] {"APE", "PEA"};
           triplet[i] = new Triplet("triplet-en-ape.off", 2, str);
           i++;

           str =  new String[] {"ARM", "RAM", "MAR", "WAR", "RAW"};
           triplet[i] = new Triplet("triplet-en-arm.off", 5, str);
           i++;

           str =  new String[] {"ART", "RAT", "TAR"};
           triplet[i] = new Triplet("triplet-en-art.off", 3, str);
           i++;

           str =  new String[] {"BAD", "DAB"};
           triplet[i] = new Triplet("triplet-en-bad.off", 2, str);
           i++;

           str =  new String[] {"BAG", "GAB"};
           triplet[i] = new Triplet("triplet-en-bag.off", 2, str);
           i++;

           str =  new String[] {"BAR", "BRA"};
           triplet[i] = new Triplet("triplet-en-bar.off", 2, str);
           i++;

           str =  new String[] {"BAT", "TAB"};
           triplet[i] = new Triplet("triplet-en-bat.off", 2, str);
           i++;

           str =  new String[] {"BED", "DEB"};
           triplet[i] = new Triplet("triplet-en-bed.off", 2, str);
           i++;

           str =  new String[] {"BEE"};
           triplet[i] = new Triplet("triplet-en-bee.off", 1, str);
           i++;

           str =  new String[] {"BEG"};
           triplet[i] = new Triplet("triplet-en-beg.off", 1, str);
           i++;

           str =  new String[] {"BET"};
           triplet[i] = new Triplet("triplet-en-bet.off", 1, str);
           i++;

           str =  new String[] {"BOW"};
           triplet[i] = new Triplet("triplet-en-bow.off", 1, str);
           i++;

           str =  new String[] {"BUG"};
           triplet[i] = new Triplet("triplet-en-bug.off", 1, str);
           i++;

           str =  new String[] {"BUS", "SUB"};
           triplet[i] = new Triplet("triplet-en-bus.off", 2, str);
           i++;

           str =  new String[] {"BYE"};
           triplet[i] = new Triplet("triplet-en-bye.off", 1, str);
           i++;

           str =  new String[] {"CAR", "ARC"};
           triplet[i] = new Triplet("triplet-en-car.off", 2, str);
           i++;

           str =  new String[] {"CAT", "ACT"};
           triplet[i] = new Triplet("triplet-en-cat.off", 2, str);
           i++;

           str =  new String[] {"CPU", "CUP"};
           triplet[i] = new Triplet("triplet-en-cpu.off", 2, str);
           i++;

           str =  new String[] {"CUP", "CPU"};
           triplet[i] = new Triplet("triplet-en-cup.off", 2, str);
           i++;

           str =  new String[] {"DAY"};
           triplet[i] = new Triplet("triplet-en-day.off", 1, str);
           i++;

           str =  new String[] {"DIG"};
           triplet[i] = new Triplet("triplet-en-dig.off", 1, str);
           i++;

           str =  new String[] {"DNA", "AND"};
           triplet[i] = new Triplet("triplet-en-dna.off", 2, str);
           i++;

           str =  new String[] {"DOG", "GOD"};
           triplet[i] = new Triplet("triplet-en-dog.off", 2, str);
           i++;

           str =  new String[] {"EAR", "ERA", "ARE"};
           triplet[i] = new Triplet("triplet-en-ear.off", 3, str);
           i++;

           str =  new String[] {"EAT", "ATE", "TEA"};
           triplet[i] = new Triplet("triplet-en-eat.off", 3, str);
           i++;

           str =  new String[] {"EGG"};
           triplet[i] = new Triplet("triplet-en-egg.off", 1, str);
           i++;

           str =  new String[] {"FAT", "AFT"};
           triplet[i] = new Triplet("triplet-en-fat.off", 2, str);
           i++;

           str =  new String[] {"FAX"};
           triplet[i] = new Triplet("triplet-en-fax.off", 1, str);
           i++;

           str =  new String[] {"FEW"};
           triplet[i] = new Triplet("triplet-en-few.off", 1, str);
           i++;

           str =  new String[] {"FOG"};
           triplet[i] = new Triplet("triplet-en-fog.off", 1, str);
           i++;

           str =  new String[] {"FOR"};
           triplet[i] = new Triplet("triplet-en-for.off", 1, str);
           i++;

           str =  new String[] {"FUR"};
           triplet[i] = new Triplet("triplet-en-fur.off", 1, str);
           i++;

           str =  new String[] {"GAG"};
           triplet[i] = new Triplet("triplet-en-gag.off", 1, str);
           i++;

           str =  new String[] {"GAP"};
           triplet[i] = new Triplet("triplet-en-gap.off", 1, str);
           i++;

           str =  new String[] {"GAS", "SAG"};
           triplet[i] = new Triplet("triplet-en-gas.off", 2, str);
           i++;

           str =  new String[] {"GUN", "GNU"};
           triplet[i] = new Triplet("triplet-en-gun.off", 2, str);
           i++;

           str =  new String[] {"HAM"};
           triplet[i] = new Triplet("triplet-en-ham.off", 1, str);
           i++;

           str =  new String[] {"HAT"};
           triplet[i] = new Triplet("triplet-en-hat.off", 1, str);
           i++;

           str =  new String[] {"HER"};
           triplet[i] = new Triplet("triplet-en-her.off", 1, str);
           i++;

           str =  new String[] {"HIM"};
           triplet[i] = new Triplet("triplet-en-him.off", 1, str);
           i++;

           str =  new String[] {"HIS"};
           triplet[i] = new Triplet("triplet-en-his.off", 1, str);
           i++;

           str =  new String[] {"HIT"};
           triplet[i] = new Triplet("triplet-en-hit.off", 1, str);
           i++;

           str =  new String[] {"ILL"};
           triplet[i] = new Triplet("triplet-en-ill.off", 1, str);
           i++;

           str =  new String[] {"ITS", "SIT"};
           triplet[i] = new Triplet("triplet-en-its.off", 2, str);
           i++;

           str =  new String[] {"JAR"};
           triplet[i] = new Triplet("triplet-en-jar.off", 1, str);
           i++;

           str =  new String[] {"KIT"};
           triplet[i] = new Triplet("triplet-en-kit.off", 1, str);
           i++;

           str =  new String[] {"LAB"};
           triplet[i] = new Triplet("triplet-en-lab.off", 1, str);
           i++;

           str =  new String[] {"LAD"};
           triplet[i] = new Triplet("triplet-en-lad.off", 1, str);
           i++;

           str =  new String[] {"LAP", "PAL"};
           triplet[i] = new Triplet("triplet-en-lap.off", 2, str);
           i++;

           str =  new String[] {"LEG", "GEL"};
           triplet[i] = new Triplet("triplet-en-leg.off", 2, str);
           i++;

           str =  new String[] {"LOG"};
           triplet[i] = new Triplet("triplet-en-log.off", 1, str);
           i++;

           str =  new String[] {"LOT"};
           triplet[i] = new Triplet("triplet-en-lot.off", 1, str);
           i++;

           str =  new String[] {"MAD", "DAM", "WAD"};
           triplet[i] = new Triplet("triplet-en-mad.off", 3, str);
           i++;

           str =  new String[] {"MOM", "WOW", "MOW"};
           triplet[i] = new Triplet("triplet-en-mom.off", 3, str);
           i++;

           str =  new String[] {"NEW", "MEN"};
           triplet[i] = new Triplet("triplet-en-new.off", 2, str);
           i++;

           str =  new String[] {"OAK"};
           triplet[i] = new Triplet("triplet-en-oak.off", 1, str);
           i++;

           str =  new String[] {"OFF"};
           triplet[i] = new Triplet("triplet-en-off.off", 1, str);
           i++;

           str =  new String[] {"OIL"};
           triplet[i] = new Triplet("triplet-en-oil.off", 1, str);
           i++;

           str =  new String[] {"OLD"};
           triplet[i] = new Triplet("triplet-en-old.off", 1, str);
           i++;

           str =  new String[] {"ORB", "ROB"};
           triplet[i] = new Triplet("triplet-en-orb.off", 2, str);
           i++;

           str =  new String[] {"OUR"};
           triplet[i] = new Triplet("triplet-en-our.off", 1, str);
           i++;

           str =  new String[] {"PAD"};
           triplet[i] = new Triplet("triplet-en-pad.off", 1, str);
           i++;

           str =  new String[] {"PEA", "APE"};
           triplet[i] = new Triplet("triplet-en-pea.off", 2, str);
           i++;

           str =  new String[] {"PEN"};
           triplet[i] = new Triplet("triplet-en-pen.off", 1, str);
           i++;

           str =  new String[] {"PET"};
           triplet[i] = new Triplet("triplet-en-pet.off", 1, str);
           i++;

           str =  new String[] {"PIE"};
           triplet[i] = new Triplet("triplet-en-pie.off", 1, str);
           i++;

           str =  new String[] {"PIG"};
           triplet[i] = new Triplet("triplet-en-pig.off", 1, str);
           i++;

           str =  new String[] {"POP"};
           triplet[i] = new Triplet("triplet-en-pop.off", 1, str);
           i++;

           str =  new String[] {"POT", "OPT", "TOP"};
           triplet[i] = new Triplet("triplet-en-pot.off", 3, str);
           i++;

           str =  new String[] {"RAG"};
           triplet[i] = new Triplet("triplet-en-rag.off", 1, str);
           i++;

           str =  new String[] {"RAT", "ART", "TAR"};
           triplet[i] = new Triplet("triplet-en-rat.off", 3, str);
           i++;

           str =  new String[] {"ARM", "RAM", "MAR", "WAR", "RAW"};
           triplet[i] = new Triplet("triplet-en-raw.off", 5, str);
           i++;

           str =  new String[] {"RED"};
           triplet[i] = new Triplet("triplet-en-red.off", 1, str);
           i++;

           str =  new String[] {"RIB"};
           triplet[i] = new Triplet("triplet-en-rib.off", 1, str);
           i++;

           str =  new String[] {"SAD"};
           triplet[i] = new Triplet("triplet-en-sad.off", 1, str);
           i++;

           str =  new String[] {"SEA"};
           triplet[i] = new Triplet("triplet-en-sea.off", 1, str);
           i++;

           str =  new String[] {"SEE"};
           triplet[i] = new Triplet("triplet-en-see.off", 1, str);
           i++;

           str =  new String[] {"SET"};
           triplet[i] = new Triplet("triplet-en-set.off", 1, str);
           i++;

           str =  new String[] {"SHE"};
           triplet[i] = new Triplet("triplet-en-she.off", 1, str);
           i++;

           str =  new String[] {"SIR", "IRS"};
           triplet[i] = new Triplet("triplet-en-sir.off", 2, str);
           i++;

           str =  new String[] {"SOS"};
           triplet[i] = new Triplet("triplet-en-sos.off", 1, str);
           i++;

           str =  new String[] {"SUN"};
           triplet[i] = new Triplet("triplet-en-sun.off", 1, str);
           i++;

           str =  new String[] {"TAG"};
           triplet[i] = new Triplet("triplet-en-tag.off", 1, str);
           i++;

           str =  new String[] {"TEA", "EAT", "ATE"};
           triplet[i] = new Triplet("triplet-en-tea.off", 3, str);
           i++;

           str =  new String[] {"THY"};
           triplet[i] = new Triplet("triplet-en-thy.off", 1, str);
           i++;

           str =  new String[] {"USA"};
           triplet[i] = new Triplet("triplet-en-usa.off", 1, str);
           i++;

           str =  new String[] {"USE", "SUE"};
           triplet[i] = new Triplet("triplet-en-use.off", 2, str);
           i++;

           str =  new String[] {"ARM", "RAM", "MAR", "WAR", "RAW"};
           triplet[i] = new Triplet("triplet-en-war.off", 5, str);
           i++;

           str =  new String[] {"WEB"};
           triplet[i] = new Triplet("triplet-en-web.off", 1, str);
           i++;

           str =  new String[] {"WET", "MET"};
           triplet[i] = new Triplet("triplet-en-wet.off", 2, str);
           i++;

           str =  new String[] {"WHY"};
           triplet[i] = new Triplet("triplet-en-why.off", 1, str);
           i++;

           str =  new String[] {"WOE", "OWE"};
           triplet[i] = new Triplet("triplet-en-woe.off", 2, str);
           i++;

           str =  new String[] {"ZIP, NIP, PIN"};
           triplet[i] = new Triplet("triplet-en-zip.off", 3, str);
           i++;

           str =  new String[] {"ZOO"};
           triplet[i] = new Triplet("triplet-en-zoo.off", 1, str);
           i++;           
       }


       i = 0;
       if (level == 3)
       {
          str =  new String[] {"ADA"};
          triplet[i] = new Triplet("triplet-es-ada.off", 1, str);
          i++;
          
          str =  new String[] {"ALA"};
          triplet[i] = new Triplet("triplet-es-ala.off", 1, str);
          i++;
          
          str =  new String[] {"AMA"};
          triplet[i] = new Triplet("triplet-es-ama.off", 1, str);
          i++;
          
          str =  new String[] {"AME", "MEA"};
          triplet[i] = new Triplet("triplet-es-ame.off", 2, str);
          i++;
          
          str =  new String[] {"AMO"};
          triplet[i] = new Triplet("triplet-es-amo.off", 1, str);
          i++;
          
          str =  new String[] {"ARA"};
          triplet[i] = new Triplet("triplet-es-ara.off", 1, str);
          i++;
          
          str =  new String[] {"ARE", "REA", "ERA"};
          triplet[i] = new Triplet("triplet-es-are.off", 3, str);
          i++;
          
          str =  new String[] {"ARO", "ROA", "ORA"};
          triplet[i] = new Triplet("triplet-es-aro.off", 3, str);
          i++;
          
          str =  new String[] {"ASA"};
          triplet[i] = new Triplet("triplet-es-asa.off", 1, str);
          i++;
          
          str =  new String[] {"ASO", "OSA"};
          triplet[i] = new Triplet("triplet-es-aso.off", 2, str);
          i++;
          
          str =  new String[] {"ATA"};
          triplet[i] = new Triplet("triplet-es-ata.off", 1, str);
          i++;
          
          str =  new String[] {"ATO", "TOA"};
          triplet[i] = new Triplet("triplet-es-ato.off", 2, str);
          i++;
          
          str =  new String[] {"AUN", "UNA"};
          triplet[i] = new Triplet("triplet-es-aun.off", 2, str);
          i++;
          
          str =  new String[] {"BAR"};
          triplet[i] = new Triplet("triplet-es-bar.off", 1, str);
          i++;
          
          str =  new String[] {"BES"};
          triplet[i] = new Triplet("triplet-es-bes.off", 1, str);
          i++;
          
          str =  new String[] {"BIT"};
          triplet[i] = new Triplet("triplet-es-bit.off", 1, str);
          i++;
          
          str =  new String[] {"BOA", "BAO"};
          triplet[i] = new Triplet("triplet-es-boa.off", 2, str);
          i++;
          
          str =  new String[] {"BUS"};
          triplet[i] = new Triplet("triplet-es-bus.off", 1, str);
          i++;
          
          str =  new String[] {"CAE"};
          triplet[i] = new Triplet("triplet-es-cae.off", 1, str);
          i++;
          
          str =  new String[] {"CAL"};
          triplet[i] = new Triplet("triplet-es-cal.off", 1, str);
          i++;
          
          str =  new String[] {"CLO", "COL"};
          triplet[i] = new Triplet("triplet-es-clo.off", 2, str);
          i++;
          
          str =  new String[] {"COZ"};
          triplet[i] = new Triplet("triplet-es-coz.off", 1, str);
          i++;
          
          str =  new String[] {"DAN"};
          triplet[i] = new Triplet("triplet-es-dan.off", 1, str);
          i++;
          
          str =  new String[] {"DAR"};
          triplet[i] = new Triplet("triplet-es-dar.off", 1, str);
          i++;
          
          str =  new String[] {"DAS"};
          triplet[i] = new Triplet("triplet-es-das.off", 1, str);
          i++;
          
          str =  new String[] {"DEL"};
          triplet[i] = new Triplet("triplet-es-del.off", 1, str);
          i++;
          
          str =  new String[] {"DEN"};
          triplet[i] = new Triplet("triplet-es-den.off", 1, str);
          i++;
          
          str =  new String[] {"DON"};
          triplet[i] = new Triplet("triplet-es-don.off", 1, str);
          i++;
          
          str =  new String[] {"DOS"};
          triplet[i] = new Triplet("triplet-es-dos.off", 1, str);
          i++;
          
          str =  new String[] {"ECO"};
          triplet[i] = new Triplet("triplet-es-eco.off", 1, str);
          i++;
          
          str =  new String[] {"EFE"};
          triplet[i] = new Triplet("triplet-es-efe.off", 1, str);
          i++;
          
          str =  new String[] {"ELE", "LEE"};
          triplet[i] = new Triplet("triplet-es-ele.off", 2, str);
          i++;
          
          str =  new String[] {"ENE"};
          triplet[i] = new Triplet("triplet-es-ene.off", 1, str);
          i++;
          
          str =  new String[] {"ESA", "SEA", "AES", "ASE"};
          triplet[i] = new Triplet("triplet-es-esa.off", 4, str);
          i++;
          
          str =  new String[] {"ESE", "ESE"};
          triplet[i] = new Triplet("triplet-es-ese.off", 2, str);
          i++;
          
          str =  new String[] {"ESO", "OES", "OSE"};
          triplet[i] = new Triplet("triplet-es-eso.off", 3, str);
          i++;
          
          str =  new String[] {"ETA", "TEA", "ATE"};
          triplet[i] = new Triplet("triplet-es-eta.off", 3, str);
          i++;
          
          str =  new String[] {"FAX"};
          triplet[i] = new Triplet("triplet-es-fax.off", 1, str);
          i++;
          
          str =  new String[] {"FAZ"};
          triplet[i] = new Triplet("triplet-es-faz.off", 1, str);
          i++;
          
          str =  new String[] {"FEA"};
          triplet[i] = new Triplet("triplet-es-fea.off", 1, str);
          i++;
          
          str =  new String[] {"FEO"};
          triplet[i] = new Triplet("triplet-es-feo.off", 1, str);
          i++;
          
          str =  new String[] {"FEZ"};
          triplet[i] = new Triplet("triplet-es-fez.off", 1, str);
          i++;
          
          str =  new String[] {"FIN"};
          triplet[i] = new Triplet("triplet-es-fin.off", 1, str);
          i++;
          
          str =  new String[] {"GAS"};
          triplet[i] = new Triplet("triplet-es-gas.off", 1, str);
          i++;
          
          str =  new String[] {"GOL"};
          triplet[i] = new Triplet("triplet-es-gol.off", 1, str);
          i++;
          
          str =  new String[] {"HAN"};
          triplet[i] = new Triplet("triplet-es-han.off", 1, str);
          i++;
          
          str =  new String[] {"HAS"};
          triplet[i] = new Triplet("triplet-es-has.off", 1, str);
          i++;
          
          str =  new String[] {"HAY"};
          triplet[i] = new Triplet("triplet-es-hay.off", 1, str);
          i++;
          
          str =  new String[] {"HAZ"};
          triplet[i] = new Triplet("triplet-es-haz.off", 1, str);
          i++;
          
          str =  new String[] {"IBA"};
          triplet[i] = new Triplet("triplet-es-iba.off", 1, str);
          i++;
          
          str =  new String[] {"IDA"};
          triplet[i] = new Triplet("triplet-es-ida.off", 1, str);
          i++;
          
          str =  new String[] {"IZA"};
          triplet[i] = new Triplet("triplet-es-iza.off", 1, str);
          i++;
          
          str =  new String[] {"JAN"};
          triplet[i] = new Triplet("triplet-es-jan.off", 1, str);
          i++;
          
          str =  new String[] {"LAR"};
          triplet[i] = new Triplet("triplet-es-lar.off", 1, str);
          i++;
          
          str =  new String[] {"LEA"};
          triplet[i] = new Triplet("triplet-es-lea.off", 1, str);
          i++;
          
          str =  new String[] {"LEN"};
          triplet[i] = new Triplet("triplet-es-len.off", 1, str);
          i++;
          
          str =  new String[] {"LID"};
          triplet[i] = new Triplet("triplet-es-lid.off", 1, str);
          i++;
          
          str =  new String[] {"LIS"};
          triplet[i] = new Triplet("triplet-es-lis.off", 1, str);
          i++;
          
          str =  new String[] {"LOA", "OLA"};
          triplet[i] = new Triplet("triplet-es-loa.off", 2, str);
          i++;
          
          str =  new String[] {"LOS", "SOL"};
          triplet[i] = new Triplet("triplet-es-los.off", 2, str);
          i++;
          
          str =  new String[] {"LUZ"};
          triplet[i] = new Triplet("triplet-es-luz.off", 1, str);
          i++;
          
          str =  new String[] {"MAL"};
          triplet[i] = new Triplet("triplet-es-mal.off", 1, str);
          i++;
          
          str =  new String[] {"MAR"};
          triplet[i] = new Triplet("triplet-es-mar.off", 1, str);
          i++;
          
          str =  new String[] {"MEA", "AME"};
          triplet[i] = new Triplet("triplet-es-mea.off", 2, str);
          i++;
          
          str =  new String[] {"MIL"};
          triplet[i] = new Triplet("triplet-es-mil.off", 1, str);
          i++;
          
          str =  new String[] {"MUS"};
          triplet[i] = new Triplet("triplet-es-mus.off", 1, str);
          i++;
          
          str =  new String[] {"NOS", "SON"};
          triplet[i] = new Triplet("triplet-es-nos.off", 2, str);
          i++;
          
          str =  new String[] {"OCA"};
          triplet[i] = new Triplet("triplet-es-oca.off", 1, str);
          i++;
          
          str =  new String[] {"ODA"};
          triplet[i] = new Triplet("triplet-es-oda.off", 1, str);
          i++;
          
          str =  new String[] {"OES", "OSE", "ESO"};
          triplet[i] = new Triplet("triplet-es-oes.off", 3, str);
          i++;
          
          str =  new String[] {"OJO"};
          triplet[i] = new Triplet("triplet-es-ojo.off", 1, str);
          i++;
          
          str =  new String[] {"OLA", "LOA"};
          triplet[i] = new Triplet("triplet-es-ola.off", 2, str);
          i++;
          
          str =  new String[] {"OLE", "LEO"};
          triplet[i] = new Triplet("triplet-es-ole.off", 2, str);
          i++;
          
          str =  new String[] {"ORA", "ROA", "ARO"};
          triplet[i] = new Triplet("triplet-es-ora.off", 3, str);
          i++;
          
          str =  new String[] {"ORO", "ROO"};
          triplet[i] = new Triplet("triplet-es-oro.off", 2, str);
          i++;
          
          str =  new String[] {"OSA", "ASO"};
          triplet[i] = new Triplet("triplet-es-osa.off", 2, str);
          i++;
          
          str =  new String[] {"OSE", "OES", "ESO"};
          triplet[i] = new Triplet("triplet-es-ose.off", 3, str);
          i++;
          
          str =  new String[] {"PAN"};
          triplet[i] = new Triplet("triplet-es-pan.off", 1, str);
          i++;
          
          str =  new String[] {"PAR"};
          triplet[i] = new Triplet("triplet-es-par.off", 1, str);
          i++;
          
          str =  new String[] {"PAZ"};
          triplet[i] = new Triplet("triplet-es-paz.off", 1, str);
          i++;
          
          str =  new String[] {"PES", "EPS"};
          triplet[i] = new Triplet("triplet-es-pes.off", 2, str);
          i++;
          
          str =  new String[] {"PEZ"};
          triplet[i] = new Triplet("triplet-es-pez.off", 1, str);
          i++;
          
          str =  new String[] {"PIE"};
          triplet[i] = new Triplet("triplet-es-pie.off", 1, str);
          i++;
          
          str =  new String[] {"POR", "PRO"};
          triplet[i] = new Triplet("triplet-es-por.off", 2, str);
          i++;
          
          str =  new String[] {"PSI"};
          triplet[i] = new Triplet("triplet-es-psi.off", 1, str);
          i++;
          
          str =  new String[] {"REA", "ERA", "ARE"};
          triplet[i] = new Triplet("triplet-es-rea.off", 3, str);
          i++;
          
          str =  new String[] {"RED"};
          triplet[i] = new Triplet("triplet-es-red.off", 1, str);
          i++;
          
          str =  new String[] {"REO", "ROE", "ORE"};
          triplet[i] = new Triplet("triplet-es-reo.off", 3, str);
          i++;
          
          str =  new String[] {"RIN"};
          triplet[i] = new Triplet("triplet-es-rin.off", 1, str);
          i++;
          
          str =  new String[] {"ROL"};
          triplet[i] = new Triplet("triplet-es-rol.off", 1, str);
          i++;
          
          str =  new String[] {"SAL", "LAS"};
          triplet[i] = new Triplet("triplet-es-sal.off", 2, str);
          i++;
          
          str =  new String[] {"SED", "DES"};
          triplet[i] = new Triplet("triplet-es-sed.off", 2, str);
          i++;
          
          str =  new String[] {"SER", "RES"};
          triplet[i] = new Triplet("triplet-es-ser.off", 2, str);
          i++;
          
          str =  new String[] {"SOR"};
          triplet[i] = new Triplet("triplet-es-sor.off", 1, str);
          i++;
          
          str =  new String[] {"SUR"};
          triplet[i] = new Triplet("triplet-es-sur.off", 1, str);
          i++;
          
          str =  new String[] {"SUS"};
          triplet[i] = new Triplet("triplet-es-sus.off", 1, str);
          i++;
          
          str =  new String[] {"TAC"};
          triplet[i] = new Triplet("triplet-es-tac.off", 1, str);
          i++;
          
          str =  new String[] {"TAL"};
          triplet[i] = new Triplet("triplet-es-tal.off", 1, str);
          i++;
          
          str =  new String[] {"TAN"};
          triplet[i] = new Triplet("triplet-es-tan.off", 1, str);
          i++;
          
          str =  new String[] {"TEN"};
          triplet[i] = new Triplet("triplet-es-ten.off", 1, str);
          i++;
          
          str =  new String[] {"TEZ"};
          triplet[i] = new Triplet("triplet-es-tez.off", 1, str);
          i++;
          
          str =  new String[] {"TIC"};
          triplet[i] = new Triplet("triplet-es-tic.off", 1, str);
          i++;
          
          str =  new String[] {"UNO"};
          triplet[i] = new Triplet("triplet-es-uno.off", 1, str);
          i++;
          
          str =  new String[] {"USA"};
          triplet[i] = new Triplet("triplet-es-usa.off", 1, str);
          i++;
          
          str =  new String[] {"USE"};
          triplet[i] = new Triplet("triplet-es-use.off", 1, str);
          i++;
          
          str =  new String[] {"USO"};
          triplet[i] = new Triplet("triplet-es-uso.off", 1, str);
          i++;
          
          str =  new String[] {"UVA"};
          triplet[i] = new Triplet("triplet-es-uva.off", 1, str);
          i++;
          
          str =  new String[] {"VOS"};
          triplet[i] = new Triplet("triplet-es-vos.off", 1, str);
          i++;
          
          str =  new String[] {"ZAR"};
          triplet[i] = new Triplet("triplet-es-zar.off", 1, str);
          i++;
          
          str =  new String[] {"ZOO"};
          triplet[i] = new Triplet("triplet-es-zoo.off", 1, str);
          i++;
       }
       
       
       lettersPanel.setLayout(new GridLayout(1, 3));
       
       letter1 = new Choice();
       letter1.add("?");
       letter1.add("A");
       letter1.add("B");
       letter1.add("C");
       letter1.add("D");
       letter1.add("E");
       letter1.add("F");
       letter1.add("G");
       letter1.add("H");
       letter1.add("I");
       letter1.add("J");
       letter1.add("K");
       letter1.add("L");
       letter1.add("M");
       letter1.add("N");
       letter1.add("O");
       letter1.add("P");
       letter1.add("Q");
       letter1.add("R");
       letter1.add("S");
       letter1.add("T");
       letter1.add("U");
       letter1.add("V");
       letter1.add("W");
       letter1.add("X");
       letter1.add("Y");
       letter1.add("Z");       
       lettersPanel.add(letter1);
       
       internalKeyListener1 = new KeyAdapter() 
       {
           public void keyPressed(KeyEvent keyEvent) 
           {
      		  letter2.requestFocus();
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_A)
         	  {        	  
         		  letter1.select("A");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_B)
         	  {        	  
         		  letter1.select("B");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_C)
         	  {        	  
         		  letter1.select("C");
         	  };         	       
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_D)
         	  {        	  
         		  letter1.select("D");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_E)
         	  {        	  
         		  letter1.select("E");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_F)
         	  {        	  
         		  letter1.select("F");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_G)
         	  {        	  
         		  letter1.select("G");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_H)
         	  {        	  
         		  letter1.select("H");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_I)
         	  {        	  
         		  letter1.select("I");
         	  };         	  
        	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_J)
         	  {        	  
         		  letter1.select("J");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_K)
         	  {        	  
         		  letter1.select("K");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_L)
         	  {        	  
         		  letter1.select("L");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_M)
         	  {        	  
         		  letter1.select("M");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_N)
         	  {        	  
         		  letter1.select("N");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_O)
         	  {        	  
         		  letter1.select("O");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_P)
         	  {        	  
         		  letter1.select("P");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_Q)
         	  {        	  
         		  letter1.select("Q");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_R)
         	  {        	  
         		  letter1.select("R");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_S)
         	  {        	  
         		  letter1.select("S");
         	  };
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_T)
         	  {        	  
         		  letter1.select("T");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_U)
         	  {        	  
         		  letter1.select("U");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_V)
         	  {        	  
         		  letter1.select("V");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_W)
         	  {        	  
         		  letter1.select("W");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_X)
         	  {        	  
         		  letter1.select("X");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_Y)
         	  {        	  
         		  letter1.select("Y");
         	  };         	  
         	        		  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_Z)
         	  {        	  
         		  letter1.select("Z");
         	  };         	  
           }
       };
       letter1.addKeyListener(internalKeyListener1);         
       
       
       letter2 = new Choice();
       letter2.add("?");
       letter2.add("A");
       letter2.add("B");
       letter2.add("C");
       letter2.add("D");
       letter2.add("E");
       letter2.add("F");
       letter2.add("G");
       letter2.add("H");
       letter2.add("I");
       letter2.add("J");
       letter2.add("K");
       letter2.add("L");
       letter2.add("M");
       letter2.add("N");
       letter2.add("O");
       letter2.add("P");
       letter2.add("Q");
       letter2.add("R");
       letter2.add("S");
       letter2.add("T");
       letter2.add("U");
       letter2.add("V");
       letter2.add("W");
       letter2.add("X");
       letter2.add("Y");
       letter2.add("Z");       
       lettersPanel.add(letter2);
       
       internalKeyListener2 = new KeyAdapter() 
       {
           public void keyPressed(KeyEvent keyEvent) 
           {
      		  letter3.requestFocus();
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_A)
         	  {        	  
         		  letter2.select("A");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_B)
         	  {        	  
         		  letter2.select("B");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_C)
         	  {        	  
         		  letter2.select("C");
         	  };         	       
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_D)
         	  {        	  
         		  letter2.select("D");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_E)
         	  {        	  
         		  letter2.select("E");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_F)
         	  {        	  
         		  letter2.select("F");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_G)
         	  {        	  
         		  letter2.select("G");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_H)
         	  {        	  
         		  letter2.select("H");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_I)
         	  {        	  
         		  letter2.select("I");
         	  };         	  
        	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_J)
         	  {        	  
         		  letter2.select("J");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_K)
         	  {        	  
         		  letter2.select("K");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_L)
         	  {        	  
         		  letter2.select("L");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_M)
         	  {        	  
         		  letter2.select("M");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_N)
         	  {        	  
         		  letter2.select("N");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_O)
         	  {        	  
         		  letter2.select("O");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_P)
         	  {        	  
         		  letter2.select("P");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_Q)
         	  {        	  
         		  letter2.select("Q");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_R)
         	  {        	  
         		  letter2.select("R");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_S)
         	  {        	  
         		  letter2.select("S");
         	  };
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_T)
         	  {        	  
         		  letter2.select("T");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_U)
         	  {        	  
         		  letter2.select("U");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_V)
         	  {        	  
         		  letter2.select("V");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_W)
         	  {        	  
         		  letter2.select("W");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_X)
         	  {        	  
         		  letter2.select("X");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_Y)
         	  {        	  
         		  letter2.select("Y");
         	  };         	  
         	        		  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_Z)
         	  {        	  
         		  letter2.select("Z");
         	  };         	  
           }
       };
       letter2.addKeyListener(internalKeyListener2);       
       
       letter3 = new Choice();
       letter3.add("?");
       letter3.add("A");
       letter3.add("B");
       letter3.add("C");
       letter3.add("D");
       letter3.add("E");
       letter3.add("F");
       letter3.add("G");
       letter3.add("H");
       letter3.add("I");
       letter3.add("J");
       letter3.add("K");
       letter3.add("L");
       letter3.add("M");
       letter3.add("N");
       letter3.add("O");
       letter3.add("P");
       letter3.add("Q");
       letter3.add("R");
       letter3.add("S");
       letter3.add("T");
       letter3.add("U");
       letter3.add("V");
       letter3.add("W");
       letter3.add("X");
       letter3.add("Y");
       letter3.add("Z");       
       lettersPanel.add(letter3);   
       
       double x = 1.0;
       internalKeyListener3 = new KeyAdapter() 
       {
           public void keyPressed(KeyEvent keyEvent) 
           {
      		  verifyButton.requestFocus();
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_A)
         	  {        	  
         		  letter3.select("A");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_B)
         	  {        	  
         		  letter3.select("B");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_C)
         	  {        	  
         		  letter3.select("C");
         	  };         	       
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_D)
         	  {        	  
         		  letter3.select("D");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_E)
         	  {        	  
         		  letter3.select("E");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_F)
         	  {        	  
         		  letter3.select("F");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_G)
         	  {        	  
         		  letter3.select("G");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_H)
         	  {        	  
         		  letter3.select("H");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_I)
         	  {        	  
         		  letter3.select("I");
         	  };         	  
        	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_J)
         	  {        	  
         		  letter3.select("J");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_K)
         	  {        	  
         		  letter3.select("K");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_L)
         	  {        	  
         		  letter3.select("L");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_M)
         	  {        	  
         		  letter3.select("M");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_N)
         	  {        	  
         		  letter3.select("N");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_O)
         	  {        	  
         		  letter3.select("O");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_P)
         	  {        	  
         		  letter3.select("P");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_Q)
         	  {        	  
         		  letter3.select("Q");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_R)
         	  {        	  
         		  letter3.select("R");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_S)
         	  {        	  
         		  letter3.select("S");
         	  };
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_T)
         	  {        	  
         		  letter3.select("T");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_U)
         	  {        	  
         		  letter3.select("U");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_V)
         	  {        	  
         		  letter3.select("V");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_W)
         	  {        	  
         		  letter3.select("W");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_X)
         	  {        	  
         		  letter3.select("X");
         	  };         	  
         	  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_Y)
         	  {        	  
         		  letter3.select("Y");
         	  };         	  
         	        		  
         	  if (keyEvent.getKeyCode() == KeyEvent.VK_Z)
         	  {        	  
         		  letter3.select("Z");
         	  };         	  
           }
       };
       letter3.addKeyListener(internalKeyListener3);       

       m_pjTriplet.loadOffFile(triplet[shuffle[idx]].getFileName());
       m_pjTriplet.poly.showEdges(true);


       super.setParent(parent);
   }; // End of setParent()


   //////////////////////////////////////////////////////////////////////////
   // Update the panel whenever the parent has changed somewhere else
   //////////////////////////////////////////////////////////////////////////
   public boolean update(Object  event)
   {
      if (m_pjTriplet == event)
      {
         // Fill here!

         return(true);
      };

      return(super.update(event));
   }; // End of update()

   
   //////////////////////////////////////////////////////////////////////////
   // Handle action events invoked from text fields
   //////////////////////////////////////////////////////////////////////////
   public void actionPerformed(ActionEvent event)
   {      
      if (m_pjTriplet == null)
      {
          return;
      };
      
      Object source = event.getSource();

      if (source == verifyButton)
      {
         String user = letter1.getSelectedItem() + letter2.getSelectedItem() + letter3.getSelectedItem();
         correct_answer = false;
         log_triplets[idx] = user;
         
         String str = "(" + user + ") ";
         
         
         for (int i = 0; i < triplet[shuffle[idx]].getNumberOfWords(); i++)
         {
             str = str + "(" + triplet[shuffle[idx]].getWords(i) + ") ";             
             if (user.equals(triplet[shuffle[idx]].getWords(i)))
             {
                 correct_answer = true;
                 break;
             }
         };
                  
         
         if (correct_answer == true)
         {             
             m_pjTriplet.rightAnswerSoundData.play();
             
             if (number_of_trials < max_number_of_trials)
             {
                score = score + 3;

                 if (viewPlanes.getState() == true)
                 {
                     score = score - 2;                 
                 }
                 else
                 {
                     if (viewAxes.getState() == true)
                     {
                        score = score - 1;     
                     }
                 }
             };

             idx++;
             
             if (idx == length)
             {
                 log_trials[idx - 1] = number_of_trials;
                
                 messageLabel.setText(end_of_the_game_trans[idiom]);
                 messageLabel.setForeground(Color.BLUE);
                 letter1.setEnabled(false);
                 letter2.setEnabled(false);
                 letter3.setEnabled(false);
                 verifyButton.setEnabled(false);

                 this.removeAll();
                                    
                 this.add(messageLabel);

                 this.add(scoreLabel);
                 this.add(new Label(" "));
                 
                 this.add(new Label(log_trans[idiom], Label.CENTER));
                 
                 log = new TextArea("", 18, 1);
                 log.setEditable(false);
                 log.setFont(new Font("Courier", Font.PLAIN, 12));
                 
                 String s = new String();
                 
                 s = "";
                 for (int i = 0; i < length - 1; i++)
                 {
                    if (log_trials[i] > 0)
                    {
                       if (log_trials[i] == 1)
                       {
                          s = s + 
                              log_triplets[i] + 
                              " (" + 
                              Integer.toString(log_trials[i]) + 
                              " " + 
                              trial_trans[idiom] + 
                              ")\n";
                       }
                       else
                       {
                           s = s + 
                               log_triplets[i] + 
                               " (" + 
                                 Integer.toString(log_trials[i]) + 
                                 " " + 
                              trials_trans[idiom] + 
                              ")\n";                           
                       }
                    }
                    else
                    {
                        s = s + 
                            log_triplets[i] + 
                            " (" + 
                            hit_trans[idiom] + 
                            ")\n";                       
                    }                        
                 }
                 
                 int i = length - 1;
                 {
                    if (log_trials[i] > 0)
                    {
                       if (log_trials[i] == 1)
                       {
                          s = s + 
                              log_triplets[i] + 
                              " (" + 
                              Integer.toString(log_trials[i]) + 
                              " " +
                              trial_trans[idiom] + 
                              ")\n";
                       }
                       else
                       {
                           s = s + 
                               log_triplets[i] + 
                               " (" + 
                                 Integer.toString(log_trials[i]) + 
                                 " " +
                              trials_trans[idiom] + 
                              ")\n";                           
                       }
                    }
                    else
                    {
                        s = s + 
                            log_triplets[i] + 
                            " (" + 
                            hit_trans[idiom] + 
                            ")\n";                       
                    }                        
                 }                 
                 log.setText(s);

                 this.add(log);                 
                 
                 this.validate(); // It's necessary to validate, otherwise
                                  // Nothing appears
                 
             }
             else
             {
                debugLabel.setText(" ");
                
                int n = idx + 1;
                if (number_of_trials < max_number_of_trials)
                {                
                       messageLabel.setText(success_trans[idiom] + n + " " + of_trans[idiom] + " " + Integer.toString(length) + "!");
                       messageLabel.setForeground(Color.BLUE);
                }
                else
                {
                       messageLabel.setText(next_trans[idiom] + n + " " + of_trans[idiom] + " " + Integer.toString(length) + "!");
                       messageLabel.setForeground(Color.BLUE);                   
                };
                                   
                log_trials[idx - 1] = number_of_trials;
                number_of_trials = 0;
                
                letter1.select("?");
                letter2.select("?");
                letter3.select("?");
                          
                m_pjTriplet.loadOffFile(triplet[shuffle[idx]].getFileName());
                m_pjTriplet.poly.showEdges(true);
                m_pjTriplet.poly.update(m_pjTriplet.poly);                
             };                
         }
         else
         {
             m_pjTriplet.wrongAnswerSoundData.play();             
             if (number_of_trials < max_number_of_trials)
             {
                score = score - 1;
             };
             if (number_of_trials > 1)
             {
                 messageLabel.setText(advice_trans[idiom]);
             }
             else
             {
                messageLabel.setText(failure_trans[idiom]);
             };
             messageLabel.setForeground(Color.RED);
             number_of_trials++;
             if (number_of_trials >= max_number_of_trials)
             {     
                String answer;
                if (triplet[shuffle[idx]].getNumberOfWords() > 1)                
                {
                     answer = answers_trans[idiom];
                }
                else
                {
                     answer = answer_trans[idiom];
                }
                   for (int i = 0; i < triplet[shuffle[idx]].getNumberOfWords() - 1; i++)
                   {
                      answer = answer + triplet[shuffle[idx]].getWords(i) + ", ";    
                   };
                   answer = answer + triplet[shuffle[idx]].getWords(triplet[shuffle[idx]].getNumberOfWords() - 1);
                messageLabel.setText(answer);
                messageLabel.setForeground(Color.BLUE);
             };
         };
         
         scoreLabel.setText(score_trans[idiom] + score);
      };      
   }; // End of actionPerformed()
   
   //////////////////////////////////////////////////////////////////////////
   // Handle action events invoked from itens
   //////////////////////////////////////////////////////////////////////////
   public void itemStateChanged(ItemEvent event)
   {
      if (m_pjTriplet == null)
      {
         return;
      };
      
      Object source = event.getSource();      
      if (source == viewAxes)
      {
          if (viewAxes.getState() == true)
          {
              m_pjTriplet.addGeometry(m_pjTriplet.axes1);
          }
          else
          {
              m_pjTriplet.removeGeometry(m_pjTriplet.axes1);
          }
      }
      
      if (source == viewPlanes)
      {
          if (viewPlanes.getState() == true)
          {
              m_pjTriplet.addGeometry(m_pjTriplet.m_xplane);
              m_pjTriplet.addGeometry(m_pjTriplet.m_yplane);
              m_pjTriplet.addGeometry(m_pjTriplet.m_zplane);              
          }
          else
          {
              m_pjTriplet.removeGeometry(m_pjTriplet.m_xplane);
              m_pjTriplet.removeGeometry(m_pjTriplet.m_yplane);
              m_pjTriplet.removeGeometry(m_pjTriplet.m_zplane);              
          }
      }          
   }; // End of itemStateChanged() 
}; // End of PjTriplet_IP class
